% Copyright (c) 2018 by P. Vanberg 
% https://github.com/pvanberg/flux-beamer
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You can find the GNU General Public License at <http://www.gnu.org/licenses/>.

\mode<presentation>

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Disclaimer: the "%" symbols inside hbox are all very important here.
% The \hbox enviroment will insert spaces whenever there's whitespace
% Adding a % at the END of each line ensures that any hard returns aren't
% interpreted as white space. This allows the color boxes to be flush against
% one another. If a faint white line appears one could probably do something like
% hspace{-1px} and add an additional pixel-or-two wide beamercolorbox.	
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Header
\setbeamertemplate{frametitle}
{
    \nointerlineskip
    \begin{beamercolorbox}[wd=\paperwidth,leftskip=0.2cm,ht=0.7cm,dp=0.3cm]{header primary}%
        \usebeamerfont{header title}\insertframetitle \
		\hfill
        \llap{\usebeamerfont{header title}\insertframesubtitle}
		\hspace*{.1in}
		% \llap{\textcolor{red}{Your Custom Text Here}\hspace*{1em}} % Custom text
    \end{beamercolorbox}%
    \nointerlineskip
    % Header shadowing
	\pgfdeclareverticalshading{beamer@topshade}{\paperwidth}{%
    color(3pt)=(primaryLight!0);
    color(4pt)=(primaryLight)}
    \begin{beamercolorbox}[wd=\paperwidth, center]{}%
		    \pgfuseshading{beamer@topshade}
    \end{beamercolorbox}%
}
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Footer
\setbeamertemplate{footline}
{%
\begin{beamercolorbox}[wd=\textwidth, center]{footer}%
	\rule{0.95\paperwidth}{0.2pt}
\end{beamercolorbox}%
\begin{beamercolorbox}[wd=\textwidth, leftskip=0.3cm,rightskip=0.3cm, ht=0.3cm,dp=0.15cm]{footer text}%
	\usebeamerfont{footnote}\copyright \ \insertauthor\hfill
	% Uncomment to display navigation button
	%\insertslidenavigationsymbol%
	%\insertframenavigationsymbol%
	%\insertsubsectionnavigationsymbol%
	%\insertsectionnavigationsymbol%
	%\insertdocnavigationsymbol%
	%\insertbackfindforwardnavigationsymbol%	
	\hfill\insertframenumber%
\end{beamercolorbox}%
}
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Custom footnote
\hfuzz=\maxdimen % Remove warning hbox overfull (TODO) 
\renewcommand\footnoterule{\color{Gray!50}\hspace*{-0.5cm}\rule{0.95\paperwidth}{0.2pt}\vspace*{0.07cm}}
\setbeamertemplate{footnote}{
	\begin{beamercolorbox}[wd=\textwidth, leftskip=0.3cm,rightskip=0.3cm]{footer text}%
	\usebeamerfont{footnote}\insertfootnotemark\insertfootnotetext
	\end{beamercolorbox}%
}
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% Title Page
\def\titlepage{\usebeamertemplate{title page}}
\def\logo@width{0.15\paperwidth}
\def\logo@height{0.11\paperheight}
\tikzset{
  sider/.style={
    draw=none,
    rectangle,
    outer xsep=-0.1mm,
    minimum height=\paperheight,
    minimum width=0.8cm,
    fill=primaryLight
  },
  icon/.style={
  	draw=none,
  	fill=primaryLight!95, 
  	minimum height=\logo@height,
  	minimum width=\logo@width,
  	text=background,
  	outer xsep=0.4cm,
  	outer ysep=0.4cm,
  	inner sep=0.3cm,
  	%rounded corners=\logo@height/2
  }
}
\setbeamertemplate{title page}
{
	\begin{frame}[plain]
    	\begin{tikzpicture}[remember picture,overlay]
    		\hspace*{-1pt}\node[anchor=west,sider] at (current page.west){};
    		\node[anchor=south west,sider, fill=primary, minimum height=0.3\paperheight] at (current page.south west){};
			\node[align=center] at (current page.center){
				\usebeamerfont{title}\color{Black}\inserttitle\\[0.3cm]
				\usebeamerfont{title}\color{Black}\insertsubtitle\\[0.1cm]
				\usebeamercolor[fg]{footer}\rule{0.7\paperwidth}{0.2pt}	\\[0.35cm]
				\usebeamerfont{author}\color{Gray}\insertauthor\\[0.3cm]
  			 \usebeamerfont{institute}\color{Gray}\insertinstitute
			};
			%\node[anchor=south,outer ysep=0.4cm] at (current page.south){\small\color{Gray!90}\insertdate};
			%\node[anchor=south east,icon] at (current page.south east)(logo){\includegraphics[width=\logo@width, height=\logo@height, keepaspectratio]{\inserttitlegraphic}};
		\end{tikzpicture}
	\end{frame}
}
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% TOC frame on new section
\AtBeginSection[]
{
\setbeamertemplate{section in toc}{
  \hspace*{0.4cm}\tikz[baseline=-0.5ex]\node[section number]{\usebeamerfont*{toc subtitle}\textbf{\inserttocsectionnumber}};
  \ \ \tikz[baseline=-0.5ex]\node[section]{\normalsize \textbf{\inserttocsection}};\\[-0.3cm]
  \hspace*{1.24cm}{\usebeamercolor*[fg]{footer} \rule{0.6\paperwidth}{0.2pt}\\\nointerlineskip}
}
 \setbeamertemplate{subsection in toc}{
  \hspace*{0.55cm}\tikz[baseline=-0.5ex]\node[subsection number, fill=secondary!80]{};
  \hspace*{0.5cm} \tikz[baseline=-0.5ex]\node[subsection]{\normalsize\inserttocsubsection};\\[-0.2cm]
}
 % Uncomment here to activate new page with section.
 %\begin{frame}{\hspace{0.5cm}}
 %	\tableofcontents[currentsection]
 %\end{frame}
}
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

\mode<all>

